(function($){ 
	$(function(){
		// Gather details from selected text
		initialFormValues();

		// ASSING EVENT HANLDERS 
		$('#css3_tooltips_insert_image').live('click', insertImageEventHanlder);
		$('#css3_tooltips_insert_video').on('click', insertVideoEventHanlder);
		$('.css3_tooltips_position').on('click', tooltipsPositionEventHanlder);
		$('#css3_tooltips_advanced').on('click', tooltipsAdvancedEventHanlder);
		$('#option_tag').on('change', tooltipsTagEventHanlder);
		$('#css3_tooltips_create').live('click', createShortcodeEventHanlder);
		$('#video_popup_close').on('click', popupCloseEventHanlder);
		$('#video_insert').on('click', videoInsertEventHanlder);
		$('#video_size').on('change', videoSizeEventHanlder);
		$('#option_content').live('mouseup keyup', tooltipsContentEventHandler);
				
	});
})(jQuery);

// CUSTOM FUNCTIONS

/**
 * Function parses the text selected in Visual Composer and determines if user 
 * is creating a new shortcode or editing the existing one. If user edits exiting 
 * shortcode, then function will gather its parameters and fill form fields with 
 * them. 
 * 
 */
function initialFormValues() {
	window.caret_pos = 0;
    var select = tinyMCEPopup.params["selected"];
    var n = select.search('[\[]css3_tooltip');
    //var text = '';
    if (n === -1) {
		// CREATE NEW SHORTCODE
		jQuery('#option_wrapped_content').val(select);
    } else {
		// MODIFY EXISTING SHORTCODE
		
		// RESET FIELD VALUES:
		resetFields();
		
		// GATHER SHORTCODE PARAMETER VALUES
		var pattern_param = /[\w_]+\s*=\s*("[^"]*"|'[^']*')/g;
		var pattern_param_name = /[a-zA-Z0-9_]*/g
		var pattern_param_value = /(".*"|'.*')/g;
		var pattern_text = /\].*\[/g;
		// ALLOWED PARAMETERS 
		var parameters = [
			"header",
			"content",
			"style",
			"position",
			"delay",
			"tag",
			"focus",
			"width",
			"custom_css_class",
			"cursor",
			"custom_css",
			"custom_content_css",
			"event"
		];

		text = select.match(pattern_text)[0];
		text = text.substr(1, text.length - 2);
		jQuery('#option_wrapped_content').val(text);

		params = select.match(pattern_param);
		if(params!==null)
			for (var i = 0; i < params.length; ++i)
			{
				param_name = params[i].match(pattern_param_name)[0];
				if (parameters.indexOf(param_name) === -1)
				continue;	//	NOT ALLOWED PARAMETER
				param_value = params[i].match(pattern_param_value)[0];
				param_value = param_value.substr(1, param_value.length - 2);
				switch (param_name) {
				case 'tag':
					if(jQuery("#option_tag option[value='"+param_value+"']").length > 0) {
						jQuery('#option_tag').val(param_value);
						//jQuery('.css3_tooltips .custom_tag').hide();
						jQuery('.css3_tooltips .custom_tag').addClass('hidden');
					} else {
						jQuery('#option_tag').val('custom_tag');
						jQuery('#option_custom_tag').val(param_value);
						jQuery('.css3_tooltips .custom_tag').removeClass('hidden');
						//jQuery('.css3_tooltips .custom_tag').show();						
					}
					break;
				case 'focus':
					jQuery('#option_' + param_name).prop('checked', true);
					break;
				case 'position':
					jQuery('.css3_tooltips_position').removeClass('active');
					jQuery('.' + param_value).addClass('active');
				default:
					jQuery('#option_' + param_name).val(param_value);
					break;
				}
			}
    }
}		/*	end of initialFormValues() function	*/


function resetFields() {
	jQuery('input[type="text"]').val('');
	jQuery('textarea').val('');
	jQuery('select').each(function(index,value){
		var $this = jQuery(this);
		$this.val($this.find('option:first-child').val());
	});
}		/*	end of resetFields() function	*/


/**
 * Return the caret position
 * @param {type} el - textarea
 * @returns {@exp;el@pro;selectionStart|Number|@exp;rc@pro;text@pro;length}
 */
function getCaret(el) {
    if (el.selectionStart) {
	return el.selectionStart;
    } else if (document.selection) {
	el.focus();

	var r = document.selection.createRange();
	if (r == null) {
	    return 0;
	}

	var re = el.createTextRange(),
		rc = re.duplicate();
	re.moveToBookmark(r.getBookmark());
	rc.setEndPoint('EndToStart', re);

	return rc.text.length;
    }
    return 0;
}

/**
 * Inserts specific text into given field at current cursor position
 * @param {type} myField
 * @param {type} myValue
 * @returns {undefined}
 */
function insertAtCursor(myField, myValue) {
    text_i = jQuery(myField).val();
    text_o = text_i.substr(0, window.caret_pos) + myValue + text_i.substr(window.caret_pos, text_i.length1);
    jQuery(myField).val(text_o);
}

/**
 * Parses URL of YouTube/Vimeo videos and returns the video type & ID
 * @param {type} jQueryurl URL of video (YouTube/Vimeo)
 * @returns {mixed} ID & type of the video
 */
function parseVideoURL(url) {
    // Video type and ID
    var output = {"type": "", "id": ""};
    if (url.indexOf('youtube.com') !== -1) {
	output.type = "youtube";
	// Extract the YouTube video ID from provided URL 
	var match = url.match(/(?:http|https|)(?::\/\/|)(?:www.|)(?:youtu\.be\/|youtube\.com(?:\/embed\/|\/v\/|\/watch\?v=|\/ytscreeningroom\?v=|\/feeds\/api\/videos\/|\/user\S*[^\w\-\s]|\S*[^\w\-\s]))([\w\-]{11})[a-z0-9;:@?&%=+\/\$_.-]*/);
	// video ID 
	output.id = match[match.length - 1];
	// video_id = match[match.length - 1];
    } else if (url.indexOf('vimeo.com') !== -1) {
	output.type = "vimeo";
	// Extract the Vimeo video ID from provided URL 
	var match = url.match(/https?:\/\/(?:www\.)?vimeo.com\/(?:channels\/|groups\/([^\/]*)\/videos\/|album\/(\d+)\/video\/|)(\d+)(?:$|\/|\?)/);
	output.id = match[match.length - 1];
    }
    return output;
}


// EVENT HANDLERS

// Handler for 'Add Image' button, will open WP Media Upload window
function insertImageEventHanlder() {
    var self = jQuery(this);
    window.send_to_editor = function(html)
    {
		var src = "", media = "";
		if (html.indexOf('img') != -1)
		{
			src = jQuery(html).find("img").attr("src");
			if(src===undefined)
				src = jQuery(html).attr('src');
			media = '<img src="' + src + '" />';
		}
		insertAtCursor(jQuery('#option_content'), media);
		tb_remove();
    }

	tb_show('Select Image', admin_url + 'media-upload.php?amp;type=image&amp;TB_iframe=true&amp;width=750');
	
	
    return false;
}   // end of insertImageEventHanlder();

function createShortcodeEventHanlder() {

    var shortcode = '[css3_tooltip';

    header = jQuery('#option_header').val();
    if (header != '')
	shortcode += " header='" + header.replace(/'/g, '"') + "' ";

    content = jQuery('#option_content').val();
		shortcode += " content='" + content.replace(/'/g, '"') + "' ";

    position = jQuery('#option_position').val();
	if (position != '' && position != 'Use Global Settings')
		shortcode += " position='" + position + "' ";

    if (jQuery('#option_focus').prop('checked'))
		shortcode += " focus='1' ";

	tag = ( jQuery('#option_tag').val()=='custom_tag' ? jQuery('#option_custom_tag').val() : jQuery('#option_tag').val() );
    if (tag != '' && tag != 'Use Global Settings')
		shortcode += " tag='" + tag + "' ";

    width = jQuery('#option_width').val();
    if (width != '' && width != 'Use Global Settings')
		shortcode += " width='" + width + "' ";

    classes = jQuery('#option_custom_css_class').val();
    if (classes != '' && classes != 'Use Global Settings')
	   shortcode += " custom_css_class='" + classes + "' ";
 
    custom_css = jQuery('#option_custom_css').val();
    if (custom_css != '' && custom_css != 'Use Global Settings')
		shortcode += " custom_css='" + custom_css.replace(/'/g, '"') + "' ";
    
	custom_content_css = jQuery('#option_custom_content_css').val();
    if (custom_content_css != '' && custom_content_css != 'Use Global Settings')
		shortcode += " custom_content_css='" + custom_content_css.replace(/'/g, '"') + "' ";
	
    style = jQuery('#option_style').val();
    if (style != '')
		shortcode += " style='" + style + "' ";

    delay = jQuery('#option_delay').val();
    if (delay != '')
		shortcode += " delay='" + delay + "' ";

    cursor = jQuery('#option_cursor').val();
    if (cursor != '')
		shortcode += " cursor='" + cursor + "' ";
    
    event = jQuery('#option_event').val();
    if (event != '')
		shortcode += " event='" + event + "' ";

    shortcode += ']';

    text = jQuery('#option_wrapped_content').val().replace(/'/g, '"');
    //shortcode += text.replace(/'/g, '"');
    shortcode += text;

    shortcode += '[/css3_tooltip]';

    // inserts the shortcode into the active editor
    tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
    tinyMCEPopup.close();

} // end of createShortcodeEventHanlder();


function insertVideoEventHanlder(event) {
    event.preventDefault();
    // Cleaning form field values
    jQuery('#video_url').val("");
    jQuery("#video_size option[value='560,315']").attr('selected', 'selected');
    jQuery('#video_width').val("");
    jQuery('#video_height').val("");
	
    // Hiding the custom_size area
    if (!jQuery('.custom_size').hasClass('hidden'))
	jQuery('.custom_size').addClass('hidden');
    // Display the popup window
    jQuery('#video_popup_wrapper').removeClass('hidden');
}   // end of insertVideoEventHanlder()

function tooltipsPositionEventHanlder() {
    jQuery('.css3_tooltips_position').removeClass('active');
    jQuery(this).addClass('active');
    value = jQuery(this).attr('class').split(' ')[1];
    jQuery('#option_position').val(value);
}   // end of tooltipsPositionEventHanlder()


function tooltipsContentEventHandler() {
    window.caret_pos = getCaret(this);
}	// end of tooltipsContentEventHandler
    
function tooltipsAdvancedEventHanlder() {
    if (jQuery(this).hasClass("show-options"))
    {
		//jQuery(".advanced").show();
		jQuery(".advanced").removeClass("hidden");
		jQuery(this).removeClass("show-options").addClass("hide-options");
		jQuery(this).val("Advanced options - Hide");
		jQuery('html, body').animate({
			scrollTop: jQuery(".advanced").first().offset().top
		}, 1000);
    } else if (jQuery(this).hasClass("hide-options"))
	{
		//jQuery(".advanced").hide();
		jQuery(".advanced").addClass("hidden");
		jQuery(this).removeClass("hide-options").addClass("show-options");
		jQuery(this).val("Advanced options - Show");
	}
}   // end of tooltipsAdvancedEventHanlder()

function videoInsertEventHanlder(event) {
    event.preventDefault();

    // Gather data from input fields        
    var video_url = jQuery('#video_url').val();
    var video_size = jQuery('#video_size').val();
    if (video_size === 'custom_size') {
	   video_size = jQuery('#video_width').val() + "," + jQuery('#video_height').val();
    }
    var video_size = video_size.split(',');
    var video_width = video_size[0];
    var video_height = video_size[1];

    // Get video type and ID
    var video_meta = parseVideoURL(video_url);

    // Prepare video embed code
    var video_embed = "";
    switch (video_meta.type) {
	case 'youtube':
	    video_embed = "<iframe width='" + video_width + "' height='" + video_height + "' src='//www.youtube.com/embed/" + video_meta.id + "' frameborder='0' allowfullscreen></iframe>";
	    break;
	case 'vimeo':
	    video_embed = "<iframe src='//player.vimeo.com/video/" + video_meta.id + "?byline=0' width='" + video_width + "' height='" + video_height + "' frameborder='0' webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>";
	    break;
	default:
	    video_embed = "";
	    break;
    } 
    // Insert prepared code into the textarea
    insertAtCursor(jQuery('#option_content'), video_embed);
    // Hide popup window
    jQuery('#video_popup_wrapper').addClass('hidden');
}   // end of videoInsertEventHanlder


function popupCloseEventHanlder(event) {
    event.preventDefault();
    jQuery('#video_popup_wrapper').addClass('hidden');
}	// end of popupCloseEventHanlder()

function tooltipsTagEventHanlder(event) {
    event.preventDefault(); 
    // Check if custom size was selected
    if (jQuery('#option_tag').val() == "custom_tag") {
//	// Display custom size fild
		jQuery('.css3_tooltips .custom_tag').removeClass('hidden');
		//jQuery('.css3_tooltips .custom_tag').show();

    } else {
		// Check if it's necessary to hide the custom size field
		//jQuery('.css3_tooltips .custom_tag').hide();
		jQuery('.css3_tooltips .custom_tag').addClass('hidden');
	}
//	if (!jQuery('.css3_tooltips .custom_tag').hasClass('hidden'))
//		jQuery('.css3_tooltips .custom_tag').addClass('hidden');
//    }
}	// end of tooltipsTagEventHanlder()

function videoSizeEventHanlder(event) {
    event.preventDefault();
    // Check if custom size was selected
    if (jQuery('#video_size').val() == "custom_size") {
	// Display custom size fild
	jQuery('#video_popup_wrapper .custom_size').removeClass('hidden');

    } else {
	// Check if it's necessary to hide the custom size field
	if (!jQuery('#video_popup_wrapper .custom_size').hasClass('hidden'))
	    jQuery('#video_popup_wrapper .custom_size').addClass('hidden');
    }
}	// end of videoSizeEventHanlder()



 



